# frozen_string_literal: true

require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to test the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator. If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails. There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.

RSpec.describe '/todos', type: :request do
  # Todo. As you add validations to Todo, be sure to
  # adjust the attributes here as well.
  let(:list_valid_attributes) { { id: 1, title: 'List Heading Example' } }

  let(:valid_attributes) do
    { id: 10, todo_list_id: 1, description: 'Todo Description example', is_complete: false }
  end

  let(:no_description_attributes) do
    { id: 10, todo_list_id: 1, description: nil, is_complete: false }
  end

  let(:no_list_attributes) do
    { id: 10, todo_list_id: nil, description: 'Todo Description example', is_complete: false }
  end

  describe 'GET /new' do
    it 'renders a successful response' do
      todo_list = TodoList.create! list_valid_attributes
      get todo_list_url(todo_list)
      expect(response).to be_successful
    end
  end

  describe 'GET /edit' do
    it 'render a successful response' do
      todo_list = TodoList.create! list_valid_attributes
      todo = Todo.create! valid_attributes
      get edit_todo_list_todo_path(todo_list, todo)
      expect(response).to be_successful
    end
  end

  describe 'POST /create' do
    context 'with valid parameters' do
      it 'creates a new Todo' do
        todo_list = TodoList.create! list_valid_attributes
        expect do
          post todo_list_todos_url(todo_list), params: { todo: valid_attributes }
        end.to change(Todo, :count).by(1)
      end

      it 'redirects to the created todo' do
        todo_list = TodoList.create! list_valid_attributes
        post todo_list_todos_url(todo_list), params: { todo: valid_attributes }
        expect(response).to redirect_to(todo_list_url(todo_list))
      end
    end

    context 'with no description' do
      it 'does not create a new Todo' do
        expect do
          todo_list = TodoList.create! list_valid_attributes
          post todo_list_todos_url(todo_list), params: { todo: no_description_attributes }
        end.to change(Todo, :count).by(0)
      end

      it "renders a successful response (i.e. to display the 'new' template)" do
        todo_list = TodoList.create! list_valid_attributes
        post todo_list_todos_url(todo_list), params: { todo: no_description_attributes }
        expect(response).to be_successful
      end
    end
  end

  describe 'DELETE /destroy' do
    it 'destroys the requested todo' do
      todo_list = TodoList.create! list_valid_attributes
      todo = Todo.create! valid_attributes
      expect do
        delete todo_list_todo_url(todo_list, todo)
      end.to change(Todo, :count).by(-1)
    end

    it 'redirects to the todos list' do
      todo_list = TodoList.create! list_valid_attributes
      todo = Todo.create! valid_attributes
      delete todo_list_todo_url(todo_list, todo)
      expect(response).to redirect_to(todo_list_url(todo_list))
    end
  end
end
